'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var useComponentSize = _interopDefault(require('@rehooks/component-size'));
var React = require('react');
var React__default = _interopDefault(React);
var reactSpring = require('react-spring');
var reactUseGesture = require('react-use-gesture');
var styled = _interopDefault(require('styled-components'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var colors = {
    bar: "#343454",
    tick: "#EDEEF2",
    grey: "#EDEEF2",
    active: "#5A2CC9"
};

var tickStyles = "\n  background-color: " + colors.tick + ";\n  border-radius: 99px;\n  bottom: 0;\n  content: \"\";\n  height: 15px;\n  position: absolute;\n  width: 2px;\n  z-index: 1;\n";
var Tick = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  background-color: ", ";\n  border-radius: 99px;\n  bottom: -40px;\n  height: 30px;\n  left: 50%;\n  position: absolute;\n  transform: translateX(-50%);\n  width: 2px;\n\n  &::after {\n    ", "\n    right: -10px;\n  }\n\n  &::before {\n    ", "\n    right: -20px;\n  }\n"], ["\n  background-color: ", ";\n  border-radius: 99px;\n  bottom: -40px;\n  height: 30px;\n  left: 50%;\n  position: absolute;\n  transform: translateX(-50%);\n  width: 2px;\n\n  &::after {\n    ", "\n    right: -10px;\n  }\n\n  &::before {\n    ", "\n    right: -20px;\n  }\n"])), colors.tick, tickStyles, tickStyles);
var Container = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: flex;\n  position: relative;\n"], ["\n  display: flex;\n  position: relative;\n"])));
var Item = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  color: ", ";\n  font-size: 18px;\n  margin: 0 5px;\n  position: relative;\n  text-align: center;\n  user-select: none;\n  width: 20px;\n  line-height: 1;\n  margin-top: 5px;\n\n  &:last-child {\n    ", " {\n      &::before,\n      &::after {\n        display: none;\n      }\n    }\n  }\n"], ["\n  color: ", ";\n  font-size: 18px;\n  margin: 0 5px;\n  position: relative;\n  text-align: center;\n  user-select: none;\n  width: 20px;\n  line-height: 1;\n  margin-top: 5px;\n\n  &:last-child {\n    ", " {\n      &::before,\n      &::after {\n        display: none;\n      }\n    }\n  }\n"])), colors.grey, Tick);
var Measure = React__default.forwardRef(function (_a, ref) {
    var steps = _a.steps, value = _a.value, onClick = _a.onClick, activeColor = _a.activeColor;
    return (React__default.createElement(Container, { ref: ref }, Array(steps)
        .fill(0)
        .map(function (number, i) { return (React__default.createElement(Item, { key: i },
        React__default.createElement("div", { onClick: function () { return onClick(i + 1); }, style: {
                cursor: "pointer",
                transition: "all .2s",
                color: value === i + 1
                    ? activeColor || colors.active
                    : colors.grey,
                transform: value === i + 1 ? "scale(1.3) translateY(-3px)" : "scale(1)"
            } }, i + 1),
        React__default.createElement(Tick, null))); })));
});
var templateObject_1, templateObject_2, templateObject_3;

var SliderContainer = styled.div(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n  display: flex;\n  height: 63px;\n  overflow: hidden;\n  position: relative;\n\n  &::after {\n    background: transparent;\n    bottom: 0;\n    content: \"\";\n    cursor: ew-resize;\n    height: 30px;\n    left: 0;\n    position: absolute;\n    right: 0;\n    z-index: 100;\n  }\n"], ["\n  display: flex;\n  height: 63px;\n  overflow: hidden;\n  position: relative;\n\n  &::after {\n    background: transparent;\n    bottom: 0;\n    content: \"\";\n    cursor: ew-resize;\n    height: 30px;\n    left: 0;\n    position: absolute;\n    right: 0;\n    z-index: 100;\n  }\n"])));
var Bar = styled.div(templateObject_2$1 || (templateObject_2$1 = __makeTemplateObject(["\n  background: ", ";\n  border-radius: 99px;\n  bottom: 0;\n  height: 30px;\n  left: 50%;\n  position: absolute;\n  width: 2px;\n  z-index: 99;\n"], ["\n  background: ", ";\n  border-radius: 99px;\n  bottom: 0;\n  height: 30px;\n  left: 50%;\n  position: absolute;\n  width: 2px;\n  z-index: 99;\n"])), function (p) { return (p.activeColor ? p.activeColor : colors.active); });
var interpolateTransform = function (x, y) {
    return "translate3D(" + x + "px, " + y + "px, 0)";
};
var Slider = function (_a) {
    var steps = _a.steps, _b = _a.value, value = _b === void 0 ? 1 : _b, onChange = _a.onChange, activeColor = _a.activeColor;
    var ref = React.useRef();
    var width = useComponentSize(ref).width;
    var stepWidth = width / steps;
    var _c = reactSpring.useSpring(function () { return ({
        xy: [0, 0]
    }); }), xy = _c[0].xy, set = _c[1];
    var bind = reactUseGesture.useDrag(function (_a) {
        var down = _a.down, delta = _a.delta, _b = _a.memo, memo = _b === void 0 ? xy.getValue() : _b;
        var x = delta[0] + memo[0];
        if (!down) {
            x = Math.min(0, Math.max(-1 * width, x));
            var newValue = Math.max(Math.round(x / stepWidth), (steps - 1) * -1);
            x = newValue * stepWidth;
            onChange(newValue * -1 + 1);
        }
        set({ xy: [x, 0] });
        return memo;
    });
    React.useEffect(function () {
        if (width) {
            set({ xy: [(value - 1) * stepWidth * -1, 0] });
        }
    }, [width, value]);
    return (React__default.createElement(SliderContainer, __assign({}, bind()),
        React__default.createElement(reactSpring.animated.div, { style: {
                position: "absolute",
                top: 0,
                left: "50%",
                zIndex: 99,
                bottom: 0,
                marginLeft: -14,
                transform: xy.interpolate(interpolateTransform),
                marginTop: "auto"
            } },
            React__default.createElement(Measure, { activeColor: activeColor, value: value, steps: steps, onClick: onChange, ref: ref })),
        React__default.createElement(Bar, { activeColor: activeColor })));
};
var templateObject_1$1, templateObject_2$1;

exports.Slider = Slider;
